/*

Serial port talk example for SerPort, copyright (C) 2007 by DM&P.
This example will show you how to use SerPort library.

*/
#include "serport.h"
#include <conio.h>
#include <stdio.h>

void main()
{
  char  c;

  printf("\nDM&P SerPort Demo Program %s %s.\n\n", __DATE__, __TIME__);
  printf("This program will send key press message via COM1. ");
  printf("Press ESC to quit.\n\n");

  /* Open COM1 */
  SerPort_Open(COM1, 4096, 0x3f8, 4);

  /* Check COM1 */
  if(SerPort_IsOk(COM1) == 0)
  {
    printf("Unable to initialize COM1.\n");
    return;
  }

  /* Set baud rate 115200 bps, no parity, 8 bits, 1 stop bit */
  SerPort_SetParam(COM1, BAUD_115200, PARITY_NO, LENGTH_8_BIT, STOPBIT_1_BIT);

  printf("Waiting key press...\n");
  while(1)
  {
    /* Detect key press and send it to COM1 */
    if(kbhit())
    {
      c = getch();
      if(c == 27)
        break;
      SerPort_SendByte(COM1, c);
    }

    /* Is any data avail on COM1 ? */
    if(SerPort_Avail(COM1))
    {
      SerPort_RecvByte(COM1, &c);
      printf("%c", c);
    }
  }

  /* Close COM1 */
  SerPort_Close(COM1);
}
